package com.example.pjsipsdktest;

import java.io.File;

import org.pjsip.pjsua.pjsua;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.csipsimple.api.SipCallSession;
import com.csipsimple.api.SipProfile;
import com.csipsimple.pjsip.CallStateCallBack;
import com.csipsimple.pjsip.PjSipService2;
import com.csipsimple.service.SipService.SameThreadException;
import com.example.pjsipsdktest.RecordButton.OnFinishedRecordListener;
import com.main.pjsip_voice.Session;

public class TestActivity extends Activity {//implements CallStateUpdate{
	private final static String Tag = "TestActivity";
	private EditText editText;
	//toCallId[]洢صͨıʶڹҶϵ绰
	public static int toCallId[]={-1};
	//״̬
	public static String state;
	//ԷsipϢ
	public static String toCall;
	public static int seconds;
	//ͨidڲ߾ܽ
	public static int callIds;
	//sip
	public static PjSipService2 sipService;
	private boolean created=false;
	private Context context;
	private MyBrocastReceiver111 mReceiver;
	
	public static String RECORD_ROOT_PATH = Environment
			.getExternalStorageDirectory().getPath() + "/pjsipsdktest/record/";
	
	@Override
	public void onCreate(Bundle b){
		super.onCreate(b);
		context=this;
//		initPjsip();
		operateSipService(true);
		setContentView(R.layout.main_activity);
		intView();
		Intent s1 = new Intent(this, RemoteService.class);
		startService(s1);
		mReceiver = new MyBrocastReceiver111();
		IntentFilter intent = new IntentFilter();
		intent.addAction("com.pjsipsdktest.kill");
		registerReceiver(mReceiver, intent);
		
		CallStateCallBack s = new CallStateCallBack() {

			   //Ϣص
			@Override
			public void inComingCall(int arg0, String arg1) {
				callIds = arg0;
				toCall = arg1;
				Log.e(Tag, arg1 + " inComingCall");
				Intent i = new Intent(context, CallActivity.class);
				i.putExtra("INCOMINGCALL", true);
				startActivity(i);
			}

			 //ͨ״̬ص
			@Override
			public void callStateUpdate(String arg0) {
				// TODO Auto-generated method stub
				Log.e(Tag, arg0 + "callStateUpdate");
				state = arg0;
			}

		/*	
			 * תͨߴͨ״̬
			 * ѡ
			 * Է
		*/	 
			@Override
			public void callStateUpdate(int arg0, String arg1, String arg2) {
				// TODO Auto-generated method stub
				Log.e(Tag, arg0 + " callingState " + arg1 + "  " + arg2);
				toCall = arg2;
				toCallId[0] = arg0;
				state = arg1;
				if("confirmed...".equals(arg1) && !(arg2.contains(" "))) {
					Intent i = new Intent(context, CallActivity.class);
					i.putExtra("INCOMINGCALL", false);
					startActivity(i);
				}		
			}

			@Override
			public void netStateUpdate(String arg0, int arg1) {
				// TODO Auto-generated method stub
				Log.e(Tag, arg0 + " netStateUpdate " + arg1 + "  " + arg1);
			}
			
		};
		sipService.setCallBack(s);
		
		
		
	}
	
	@Override
	public void onStop() {
//		
		super.onStop();
//		operateSipService(false);
	}
	
	public void intView(){
		final EditText eServerIp=(EditText) findViewById(R.id.test_edit_server_ip);
		final EditText eUserId=(EditText) findViewById(R.id.test_edit_uid);
		final EditText ePass=(EditText) findViewById(R.id.test_edit_pass);
		final RecordButton testRestart = (RecordButton) findViewById(R.id.button1);
		if(!getFromMemory(context, "serverIp").equals("")){
			eServerIp.setText(getFromMemory(context, "serverIp"));
			eUserId.setText(getFromMemory(context, "userId"));
			ePass.setText(getFromMemory(context, "pass"));
		}
		Button register=(Button)findViewById(R.id.test_tv_register);
		
		register.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				final String serverIp=eServerIp.getText().toString().trim();
				final String userId=eUserId.getText().toString().trim();
				final String pass=ePass.getText().toString().trim();
				saveToMemory(context, "serverIp", serverIp);
				saveToMemory(context, "userId", userId);
				saveToMemory(context, "pass", pass);
				if(serverIp.equals("")||userId.equals("")){
					//ignore
				}else{
					Session.setServerIP(serverIp);
					SipProfile file1=Session.buildAccount(userId, userId, serverIp, pass);
					/*
					 * SIP
					 * 
					 */
					
					//÷IP
					Session.setServerIP("192.168.1.6");
					//SIP˺
					SipProfile file=Session.buildAccount("6301", "6301", "192.162.1.6", "123456");
					//SIP˺
					Session.setSipProfile(file);
					
					try {					
						//עsipfalseʾǿעᣬ˺ʱἷǰһ˺
						if(sipService.setAccountRegistration(file, 1, false)){
							Session.getSipProfile().active=true;
						    Log.v(Tag, "register success");
						}else{
							Log.v(Tag, "register failed");
						}
					} catch (SameThreadException e) {
						e.printStackTrace();
					}
			
				}
				
			}
		});
		editText=(EditText) findViewById(R.id.test_edit_call_to);
		Button hang_up=(Button)findViewById(R.id.test_tv_hang_up);
		hang_up.setOnClickListener(whenClickHangUp);
		Button makeCall=(Button)findViewById(R.id.test_tv_make_call);
		makeCall.setOnClickListener(whenClickMakeCall);
		
		
		String path = RECORD_ROOT_PATH;
		File file = new File(path);
		file.mkdirs();
		path += "/" + System.currentTimeMillis() + ".amr";
		testRestart.setSavePath(path);
		testRestart.setOnFinishedRecordListener(new OnFinishedRecordListener() {
			@Override
			public void onFinishedRecord(String audioPath, int time) {						
				if (audioPath != null) {
					
				}

			}
		});
		
		
	}
	
	public static void saveToMemory(Context context,String key,String value){
		SharedPreferences userInfo = context.getSharedPreferences("account", 0);  
        userInfo.edit().putString(key, value).commit();  
	}
	
	public static String getFromMemory(Context context,String key){
		SharedPreferences userInfo = context.getSharedPreferences("account", 0); 
		return userInfo.getString(key, "");
	}
	
	private View.OnClickListener whenClickMakeCall=new View.OnClickListener() {
		
		@Override
		public void onClick(View v) {
			String toCall=editText.getText().toString().trim();
			try {
				//绰
				makeCall(toCall, 1, null);			
			} catch (SameThreadException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		
		}
	};
	
	private View.OnClickListener whenClickHangUp = new View.OnClickListener() {

		@Override
		public void onClick(View v) {
			if(toCallId[0]!=-1)
				try {
					callHangup(toCallId[0],SipCallSession.StatusCode.DECLINE);
				} catch (SameThreadException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
		}
	};
	
	
	
	public void initPjsip() {
		operateSipService(true);
		Session.setServerIP("121.201.16.25:7080");
		com.csipsimple.api.SipProfile file=Session.buildAccount("8004", "8004", "121.201.16.25:7080", "80048004");
//		com.csipsimple.api.SipProfile file=Session.buildAccount(sipaccount, sipaccount, host, pssword);
		Session.setSipProfile(file);
			
		try {
			if(sipService.setAccountRegistration(file, 1, false)){
				Session.getSipProfile().active=true;
			}else{				
			}
		} catch (SameThreadException e) {
			e.printStackTrace();
		}			
	}
	
	/**
	 * 
	 * @param lauch if true launch sip service ,else stop sip service
	 */
	private void operateSipService(boolean lauch) {
		if(sipService==null) {
			created = true;
			sipService=PjSipService2.instance(this);	
			//SIPЭջ
			sipService.tryToLoadStack();
		}

		if(lauch){
			try {
				//SIP
				sipService.launchPjSip();		
					created = true;			
			} catch (SameThreadException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} 
		}else{
			try {
				//ֹͣSIP
				sipService.sipStop();	
				created = false;
			} catch (SameThreadException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	
		/**
	     * 绰
	     * 
	     * @param  callee 				Ҫĺ
	     *            	   accountId 		 	˻ã˺Ŵ˲Ϊ1
	     *            	   b						˲ƵͨΪnull
		 * @return 
	     */
	    public  int makeCall(String callee, int accountId, Bundle b) throws SameThreadException {
	        if (!created) {
	            return -1;
	        }  
	        return sipService.makeCall(callee, accountId, b,toCallId);    
	    }

	    /**
	     * Ҷϡ绰
	     * 
	     * @param callId Դڣͨʱ᷵һͨıʶ
	     * @param code ڶͨʶĲ SipCallSession.StatusCode.DECLINEʾҶ
	     * @return
	     */
	    public  int  callHangup(int callId, int code) throws SameThreadException {
	        if (created) {
	            return pjsua.call_hangup(callId, code, null, null);
	        }
	        return -1;
	    }

	  /*  //Ϣص
		@Override
		public void inComingCall(int arg0, String arg1) {
			callIds = arg0;
			toCall = arg1;
			Log.e(Tag, arg1 + " inComingCall");
			Intent i = new Intent(context, CallActivity.class);
			i.putExtra("INCOMINGCALL", true);
			startActivity(i);
		}

		 //ͨ״̬ص
		@Override
		public void callStateUpdate(String arg0) {
			// TODO Auto-generated method stub
			Log.e(Tag, arg0 + "callStateUpdate");
			state = arg0;
		}

		
		 * תͨߴͨ״̬
		 * ѡ
		 * Է
		 
		@Override
		public void callStateUpdate(int arg0, String arg1, String arg2) {
			// TODO Auto-generated method stub
			Log.e(Tag, arg0 + " callingState " + arg1 + "  " + arg2);
			toCall = arg2;
			toCallId[0] = arg0;
			state = arg1;
			if("confirmed...".equals(arg1) && !(arg2.contains(" "))) {
				Intent i = new Intent(context, CallActivity.class);
				i.putExtra("INCOMINGCALL", false);
				startActivity(i);
			}		
		}
*/
	    class MyBrocastReceiver111 extends BroadcastReceiver {

			@Override
			public void onReceive(Context context, Intent intent) {
				// TODO Auto-generated method stub
				if(intent.getAction().equals("com.pjsipsdktest.kill")) {
					operateSipService(false);
					Log.e(Tag, intent.getAction());
//					Toast.makeText(context, intent.getAction(), 0).show();
					android.os.Process.killProcess(android.os.Process.myPid());

			    }
			}			
		}
	
		
		
}
